/**
 * @file
 * Javascript for the module.
 */

/**
 * Provide a slider for the slider widget.
 */
(function ($) {
  Drupal.behaviors.numeric_interval_slider = {
    attach: function(context) {
      // Hide the wrapper.
      $('div.field-widget-numeric-interval-slider div.form-type-textfield', context).hide();

      // Add the sider.
      $('div.field-widget-numeric-interval-slider', context).each(function() {
        // Store the element's ID.
        var field_name = $(this).attr('id');
        // Replace all "-" character to "_".
        field_name = field_name.replace(/-/g, '_');
        // Remove "edit_" form the begining of the string.
        field_name = field_name.replace('edit_', '');

        // Save minimum and maximum values.
        var min = parseInt(eval('Drupal.settings.numeric_interval.' + field_name + '.min'));
        var max = parseInt(eval('Drupal.settings.numeric_interval.' + field_name + '.max'));

        $('.fieldset-wrapper', $(this)).each(function() {
          // Store the slider DOM element and the default values.
          var slider_element = $(this);
          var first_val = $('input.edit-field-numeric-interval:first', slider_element).val();
          var second_val = $('input.edit-field-numeric-interval:last', slider_element).val();
          // Create wrappers to show actual slider values.
          slider_element.before('<span class="slider-first-val">' + first_val + '</span>');
          slider_element.after('<span class="slider-second-val">' + second_val + '</span>');
          // Create the slider.
          slider_element.slider({
            range: true,
            min: min,
            max: max,
            values: [ first_val, second_val ],
            slide: function( event, ui ) {
              // Update the textfields.
              $('input.edit-field-numeric-interval:first', slider_element).val(ui.values[0]);
              $('input.edit-field-numeric-interval:last', slider_element).val(ui.values[1]);
              // Update the wrappers.
              slider_element.prev('.slider-first-val').html(ui.values[0]);
              slider_element.next('.slider-second-val').html(ui.values[1]);
            }
          });
        });
      });
    }
  }
})(jQuery);
